* rbtree.c
	Implement rbtree with parent pointer, using in-place delete
	and iterator methods (see CJK algorithm book).

	Implement a search function for rb tress that performs rotations
	and changes node colors on the way down the tree to ensure that
	the node at the bottom of the search path is not a 2-node (not
	having one or two red children, with sentinel: both children black).

	Use this function to implement a remove function for rbtrees:
	Find the node to be deleted, continue the search to a 3-node or
	4-node at the bottom of the path, and move the successor from
	the bottom to replace the deleted node.
